//------------------------------------
// O[o֐
//------------------------------------
static void SetClock(char *time_dt);
static void ReadClock(char *time_dt);

static int _ini = 0 ;

// ȈՔŁEԓ̓`FbNe[u
struct time_tbl {
	char *str;
	int  min;
	int  max;
};
// ȈՔŁEԓ̓`FbNf[^
const struct time_tbl tmtb[] = {
	"year  ",	0, 99,
	"month ",	1, 12,
	"date  ",	1, 31,
	"hour  ",	0, 23,
	"minute",	0, 59,
	"second",	0, 59,
};
#define	CLK_ARY		6		// ԃf[^z
int	time_dt[CLK_ARY];		// ԃf[^z

// GPIO`
#define	RTC_CLK	0x02000000		// NbN
#define	RTC_RDT	0x08000000		// f[^FM
#define	RTC_WDT	0x04000000		// f[^FM
#define	RTC_SEL	0x00000010		// `bvZNg

#define	ON	1
#define	OFF	0

/* -------------------------------------------
300nsPʂ̃EGCg  (NbNQUUl)
    100nsPʂł݂R{ɂĂ
 ---------------------------------------------*/
static void rtc_wait(int a)
{
	int i;

//	for (a = a * 5 / 3 , i = 0 ; i < a ;  ) {
	for (a = a * 5 , i = 0 ; i < a ;  ) {
		i++;
	}
}
/* -------------------------------------------
w背WX^֏
 ---------------------------------------------*/
static void write_reg(unsigned int regAdr,unsigned int dt)
{
	*((unsigned int *)regAdr) = dt;
}
/* -------------------------------------------
w背WX^ǂݍ
 ---------------------------------------------*/
static int read_reg(unsigned int regAdr )
{
	return (*((unsigned int *)regAdr));
}
/* -------------------------------------------
w背WX^ւPrbg
 ---------------------------------------------*/
static void write_1bit(unsigned int regAdr, unsigned int dt, int flag)
{
	unsigned int rd = *((unsigned int *)regAdr);
	if (flag == ON) {
		rd |= dt;
	}
	else {
		rd &= ~dt;
	}
	*((unsigned int *)regAdr) = rd;
}
/* -------------------------------------------
w背WX^ւPrbgǂݍ
 ---------------------------------------------*/
static int read_1bit(unsigned int regAdr, unsigned int dt)
{
	unsigned int rd = *((unsigned int *)regAdr);
	return	(rd & dt);
}

/* -------------------------------------------
  qsbFPrbgf[^[h
 ---------------------------------------------*/
static void RtcReadByte(int *dt)
{
	int	i, orbit;
	for ( i = 0, *dt = 0, orbit = 0x80 ; i < 8 ; i++, orbit >>= 1) {
		// NbN
		rtc_wait(10);
		write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_CLK, ON);	// NbNghfg
		rtc_wait(10);
		write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_CLK, OFF);	// NbNknv
		// f[^M
		if (read_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_RDT)) {
			*dt |= orbit;		// f[^f
		}
	}
}

/* -------------------------------------------
  qsbFPrbgf[^Cg
 ---------------------------------------------*/
static void RtcWriteByte(int dt)
{
	int	i, orbit;

	rtc_wait(10);
	for ( i = 0, orbit = 0x80 ; i < 8 ; i++, orbit >>= 1) {
		// f[^ݒ
		if (dt & orbit)	{
			write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_WDT, ON);	// f[^ghfg
		}
		else {
			write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_WDT, OFF);	// f[^knv
		}
		// NbN
		write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_CLK, ON);	// NbNghfg
		rtc_wait(10);
		write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_CLK, OFF);	// NbNknv
		rtc_wait(10);
	}
}

/* -------------------------------------------
  qsbFf[^[h
 ---------------------------------------------*/
int RtcRead(int pos)
{
	int dt;

	// `bvZNgnm
	write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_SEL, ON);

	// EGCgF32us
	rtc_wait(320);

	// Mf[^쐬
	dt = 0x0c | (pos<<4);		// R}hf[^쐬
	RtcWriteByte(dt);			// 

	// M
	RtcReadByte(&dt);			// ǂݍ

	// `bvZNgnee
	write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_SEL, OFF);

	// EGCgF64us
	rtc_wait(640);

	// Mf[^^[
	return	dt;
}

/* -------------------------------------------
  qsbFQoCg
 ---------------------------------------------*/
void RtcWrite(int dt1, int dt2)
{
	// `bvZNgnm
	write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_SEL, ON);

	// EGCgF32us
	rtc_wait(320);

	// M
	RtcWriteByte(dt1);			// 
	RtcWriteByte(dt2);			// 

	// `bvZNgnee
	write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_SEL, OFF);

	// EGCgF64us
	rtc_wait(640);

}
/* -------------------------------------------
  qsbFqsbp
 ---------------------------------------------*/
void RtcInit(void)
{
#ifdef LINUX_____________________________________
	// GPIO b
	write_reg(VR5701_GIU_DIR0,0xf7ebffdf);
	write_reg(VR5701_GIU_DIR1,0x000007fa);
	write_reg(VR5701_GIU_FUNCSEL0,0xffc1ffff);	// 0xf1c1ffffύX
	write_reg(VR5701_GIU_FUNCSEL1,0x000007f0);
#endif

	write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_SEL, OFF);	// `bvZNgnee
	write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_CLK, OFF);	// NbNknv
	write_1bit(VR5701_IO_BASE+GIU_PIO0, RTC_WDT, OFF);	// o̓f[^knv

	rtc_wait(2);
}

#if 0
/* -------------------------------------------
  qsbFԕ\
 ---------------------------------------------*/
void DispClock(int *str)
{
	char buf[CLK_ARY*3];
	char spre[CLK_ARY];
	int	i;

	// Zp[^ݒ
	spre[0] = '/';
	spre[1] = '/';
	spre[2] = ' ';
	spre[3] = ':';
	spre[4] = ':';
	spre[5] = ' ';

	// NʐݒF20xxN
	buf[0] = '2';
	buf[1] = '0';

	// \
	for ( i = 0 ; i < CLK_ARY ; i++ ) {
		buf[2+i*3+0] = (char)('0' + ((str[i]>>4)&0x0f)%10);
		buf[2+i*3+1] = (char)('0' + ((str[i])&0x0f)%10);
		buf[2+i*3+2] = spre[i];
		buf[2+i*3+3] = 0;
	}
	printf(buf);
	printf("\n");
}

/* -------------------------------------------
  qsbFPPʂ̎ԓ
 ---------------------------------------------*/
int InputClock(char *str, int mn, int mx )
{
	char buf[64];
	int	a;

	// f[^
	printf( str ) ;
	printf ( " -> 20" ) ;
	scanf( buf );
	buf[2] = 0;

	// ̓`FbN
	if ( buf[0] == 'q') {
		return	-1;		// quit
	}
	if ( !(buf[0] >= '0' && buf[0] <= '9') ) {
		return	-2;		// ̓G[
	}
	if ( !(buf[1] == 0 || (buf[1] >= '0' && buf[1] <= '9')) ) {
		return	-2;		// ̓G[
	}

	// f[^
	a = (int)AtoL( buf );

	// ͔͈̓`FbN
	if ( a < mn || a > mx ) {
		return	-2;		// ̓G[
	}

	// I
	return a;
}

/* -------------------------------------------
  qsbFԓ
	0:OK
	1:QUIT
 ---------------------------------------------*/
int InputAllClock(int *str )
{
	int	i,ret;

	printf("\n q: quit\n");
	for( i = 0 ; i < CLK_ARY ; ) {
		str[i] = 0;
		ret = InputClock(tmtb[i].str, tmtb[i].min , tmtb[i].max );
		if ( ret == -2) {
			printf("****** error retry *****\n");
			continue;	// ̓G[
		}
		if ( ret == -1) {
			return 1;	// QUIT
		}
		ret %= 100;
		str[i] = (ret % 10) + ((ret / 10) * 16);
		i++;
	}
	return 0;
}
#endif

/* -------------------------------------------
  qsbFԐݒ
 ---------------------------------------------*/
void SetClock(char *time_dt)
{
	if( !_ini ){
		_ini = 1;
		RtcInit();
	}
//	// Ԃ
//	if (InputAllClock(time_dt)) {
//		return;	// QUIT
//	}

	// Ԑݒ
	RtcWrite(0x68, time_dt[0]);
	RtcWrite(0x58, time_dt[1]);
	RtcWrite(0x48, time_dt[2]);
	RtcWrite(0x28, time_dt[3]);
	RtcWrite(0x18, time_dt[4]);
	RtcWrite(0x08, time_dt[5]);

//	// ͓e\
//	printf("\nset clock = ");
//	DispClock(time_dt);
}

/* -------------------------------------------
  qsbFԕ\
 ---------------------------------------------*/
void ReadClock(char *time_dt)
{
	if( !_ini ){
		_ini = 1;
		RtcInit();
	}
	
	// Ԃ擾
	time_dt[0] = 0x99;
	time_dt[1] = 0x12;
	time_dt[2] = 0x31;
	time_dt[3] = 0x23;
	time_dt[4] = 0x59;
	time_dt[5] = 0x59;

	// ԓǂݍ
	time_dt[0] = RtcRead(6);	//@N
	time_dt[1] = RtcRead(5);	//@
	time_dt[2] = RtcRead(4);	//@
	time_dt[3] = RtcRead(2);	//@
	time_dt[4] = RtcRead(1);	//@
	time_dt[5] = RtcRead(0);	//@b

//	// Ԃ\
//	DispClock(time_dt);
}

#if 0
/* -------------------------------------------
  qsbFj^
 ---------------------------------------------*/
void rtcTest(void)
{
	char buf[256];
	int	ret;
	int	loop = 1;

	RtcInit();

	while(loop) {
		printf("\nRTC test start. \n");
		printf(" w: write clock \n");
		printf(" r: read clock \n");
		printf(" q: quit\n");
		printf(">");
		scanf( buf ); printf("\n");

		switch ( buf[0] ) {
		case 'q':
			loop = 0;		/* loop break */
			break;
		case 'w':
			SetClock();
			break;
		case 'r':
			ReadClock();
			break;
		}
	}
}
#endif
